#include <opencv2/highgui/highgui.hpp>
#include "../../Include/iANPRinterface.h"
#include <stdio.h>
#include <Windows.h>

void Memory( char* name )
{
	//  
	FILE* f = fopen( name, "rb" );
	
	long size;

	fseek( f, 0, SEEK_END );
	size = ftell( f );
	fseek( f, 0, SEEK_SET);

	char* buffer = new char[size];	
	fread( buffer, size, 1, f );

	fclose(f);

	//   
	CvRect Rects[100];
	int all = 100;
	char** res = new char*[all];
	for(int j=0;j<all;j++) res[j] = new char[20];
	ANPR_OPTIONS a;
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 25000;
	a.max_text_size = 20;		
	a.type_number = ANPR_RUSSIAN_BASE;
	a.flags = 0;
	int i = anprPlateMemory( buffer, size,  a, &all, Rects, res ); 
	if ( i == 0 )
		for( int j = 0; j < all; j++ ) {				
			printf( "Mode:Mem; Num:%s\n", res[j] );
	}

	for(int j=0;j<100;j++) delete [] res[j];
	delete [] res;

	delete [] buffer;
}

void WithMat( char* name )
{
	cv::Mat mat = cv::imread( name, CV_LOAD_IMAGE_GRAYSCALE );

	//   
	CvRect Rects[100];
	int all = 100;
	char** res = new char*[all];
	for(int j=0;j<all;j++) res[j] = new char[20];
	ANPR_OPTIONS a;
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 25000;
	a.max_text_size = 20;		
	a.type_number = ANPR_RUSSIAN_BASE;
	a.flags = 0;
	int i = anprPlateMatRect( mat,  cv::Rect( 0, 0, mat.cols, mat.rows ), a, &all, Rects, res ); 
	if ( i == 0 )
		for( int j = 0; j < all; j++ ) {				
			printf( "Mode:Mat; Num:%s\n", res[j] );
	}

	for(int j=0;j<100;j++) delete [] res[j];
	delete [] res;
}

void XMLWork( char* name )
{
	IplImage* Img = cvLoadImage( name, CV_LOAD_IMAGE_GRAYSCALE  );
	if ( Img == NULL ){
		printf( "Cann't load file!");		
	}

	ANPR_OPTIONS a;
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 25000;
	a.max_text_size = 20;		
	a.type_number = ANPR_RUSSIAN_BASE;
	a.flags = 0;
	char xml[1000];
	int size = 1000;
	CvRect Rect = cvRect( 0, 0, Img->width, Img->height );

	int i = anprPlateRectXML( Img,  Rect, a, xml, &size ); 			
	if ( i == 0 )
		printf( "%s\n", xml );

	cvReleaseImage ( &Img );
}

void XMLWork2( char* name )
{
	cv::Mat mat = cv::imread( name, CV_LOAD_IMAGE_GRAYSCALE );

	//   	
	ANPR_OPTIONS a;
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 25000;
	a.max_text_size = 20;		
	a.type_number = ANPR_RUSSIAN_BASE;
	a.flags = 0;
	char xml[1000];
	int size = 1000;
	int i = anprPlateMatRectXML( mat,  cv::Rect( 0, 0, mat.cols, mat.rows ), a, xml, &size ); 
	if ( i == 0 )
		printf( "%s\n", xml );	
}

/*
	 :
	image_new <file> <mode>
*/
int main( int argc, char** argv)
{
	if ( argc > 2 )
	{
		int mode = atoi( argv[2] );
		switch ( mode )
		{
		// anprPlateMemory -   
		case 0:
			Memory( argv[1] );
			break;
		// anprPlateMat -   cpp  OpenCV
		case 1:
			WithMat( argv[1] );
			break;
		// XML anprPlateRectXML
		case 2:
			XMLWork( argv[1] );
			break;
		// XML 
		case 3:
			XMLWork2( argv[1] );
			break;
		}	
	}
	return 0;
}